//+------------------------------------------------------------------+
//|                                         Wilder's DMI Signals.mq4 |
//|                                                            by: E |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "by: E"


#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_width1 2
#property indicator_width2 2



extern int    TimeFrame  = 0;
extern int    DMI.Length = 14;
extern int    Level      = 20;
extern bool   SoundAlert = true;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];

//---
double prev;
double b4plusdi, b4minusdi,nowplusdi, nowminusdi;
int    nShift;
double alertBar;



int init()
  {
//---- 
    SetIndexStyle(0, DRAW_ARROW);
    SetIndexArrow(0, 233);
    SetIndexBuffer(0, ExtMapBuffer1);
//----
    SetIndexStyle(1, DRAW_ARROW);
    SetIndexArrow(1, 234);
    SetIndexBuffer(1, ExtMapBuffer2);
//----
switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   IndicatorShortName("Wilder\'s DMI Signals: ("+TimeFrameStr+")");


//----
   return(0);
  }


int deinit()
  {
   return(0);
  }
  


int start()
  {
//----
    double buffer1Value=0;
   double buffer2Value=0;
   
   
   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted(); 

   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit= Bars-counted_bars/Period();
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;
//----
   b4plusdi   = iCustom(Symbol(),TimeFrame,"Wilder\'s DMI book",DMI.Length,false,false,Level,0,y+1);
   nowplusdi  = iCustom(Symbol(),TimeFrame,"Wilder\'s DMI book",DMI.Length,false,false,Level,0,y);
   b4minusdi  = iCustom(Symbol(),TimeFrame,"Wilder\'s DMI book",DMI.Length,false,false,Level,1,y+1);
   nowminusdi = iCustom(Symbol(),TimeFrame,"Wilder\'s DMI book",DMI.Length,false,false,Level,1,y);
   nShift     = iATR(NULL,0,100,i)*0.5;  
//----
   ExtMapBuffer1[i] = EMPTY_VALUE; ExtMapBuffer2[i] = EMPTY_VALUE;
//----
   if(b4plusdi > b4minusdi && nowplusdi < nowminusdi)
   {
      ExtMapBuffer2[i] = High[i] + nShift*Point;
      buffer1Value=High[i] + nShift*Point;
   }
//----

    if(b4plusdi < b4minusdi && nowplusdi > nowminusdi)
    {
      ExtMapBuffer1[i] = Low[i] - nShift*Point; 
      buffer2Value=Low[i] - nShift*Point; 
    }
//----
    if(prev == 0 && buffer1Value > buffer2Value) prev =1;
    if(prev == 0 && buffer1Value < buffer2Value) prev =2;
    if(prev == 1 && buffer1Value > buffer2Value &&  buffer1Value != EMPTY_VALUE && SoundAlert == true && Bars>alertBar) {Alert("Wilder\'s DMI Signals going Down " + Symbol() + " on the " +  TimeFrame + " minute chart.");alertBar = Bars;prev = 2;}
    if(prev == 2 && buffer1Value < buffer2Value &&  buffer2Value != EMPTY_VALUE && SoundAlert == true && Bars>alertBar) {Alert("Wilder\'s DMI Signals going Up " + Symbol() + " on the " +  TimeFrame + " minute chart.");alertBar = Bars;prev = 1;}
//----
}
   return(0);
  }
//+------------------------------------------------------------------+